
/*********************************************************************************
*  
*  FILE NAME     : can_smtemp.h
*  AUTHOR        : Jimmy Wu
*  CREATED DATE  : 2011-10-18 9:37:18
*  VERSION       : V1.0
*  DESCRIPTION   : ACU+ communicates with SM Temp via CAN bus, for CR command.
*  
*  CHANGE HISTORY: 
*  
*********************************************************************************/

#ifndef __CAN_SAMPLER_SMTEMP_H
#define __CAN_SAMPLER_SMTEMP_H
#include <stdio.h>
#include "basetypes.h"
#include "err_code.h"
#include "pubfunc.h"
#include "string.h"

#include "can_sampler_main.h"

#define SMTEMP_SCAN_TRY_TIME				3

#define	SMTEMP_CH_END_FLAG				-1

#define SMTEMP_CH_PER_CH				50



#define SMTEMP_B_COMMFAIL_TIME			3



#define CAN_SMTEMP_MAX_NUM		8	//ACU+ max support 8 SM_Temp
#define SMTEMP_EQUIP_ID			709
#define FLAG_CLS_ALARM			1
#define FLAG_NO_CLS_ALARM		0
#define SIG_ID_CLS_ALARM		20


#define SMTEMP_FRAME_BYTE2_NORMAL	0x00
#define SMTEMP_FRAME_BYTE2_UPDATE	0x80 // 80 for update inventory;00 for not
#define SMTEMP_FRAME_BYTE3		0x00


#define SMTEMP_CMD00_RCV_FRAMES_NUM		11
#define SMTEMP_FRAME_FRAME_INTTERVAL		5
#define SMTEMP_FRAME_ENOUGH_LONG_WAIT_TIME	50

enum ENUM_SMTEMP_CONST_VARS
{
	CAN_SMTEMP_INVALID_VALUE = -9999,
	CAN_SMTEMP_INVALID_DISP = -9998,
	CAN_INVALID_TEMP_VALUE = -273,
	CAN_SMTEMP_EXIST	= 0,
	CAN_SMTEMP_NON_EXIST	= 1,
	CAN_SMTEMP_COMM_OK	= 0,
	CAN_SMTEMP_COMM_FAIL	= 1,	

	SMTEMP_SIG_TYPE_FLOAT = 0,
	SMTEMP_SIG_TYPE_ULONG = 1,
	SMTEMP_SIG_TYPE_BYTE = 2,
	SMTEMP_SIG_TYPE_BITS = 3,
};
enum SMTEMP_SAMP_CHANNEL
{
	//Group Signals
	SM_CH_SMTEMP_NUM = 9950,
	SM_CH_SMTEMP_GROUP_COMM_STATE,
	SM_CH_SMTEMP_GROUP_EXISTE_STATE,

	//single smtemp signals
	SM_CH_SMTEMP_TEMP1 = 10000,
	SM_CH_SMTEMP_TEMP2,
	SM_CH_SMTEMP_TEMP3,
	SM_CH_SMTEMP_TEMP4,
	SM_CH_SMTEMP_TEMP5,
	SM_CH_SMTEMP_TEMP6,
	SM_CH_SMTEMP_TEMP7,
	SM_CH_SMTEMP_TEMP8,

	SM_CH_SMTEMP_TEMP1_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP2_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP3_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP4_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP5_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP6_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP7_PROBE_STATUS,
	SM_CH_SMTEMP_TEMP8_PROBE_STATUS,

	SM_CH_SMTEMP_MODULE_ID_OVERLAP,
	SM_CH_SMTEMP_AD_CONV_FAILURE,
	SM_CH_SMTEMP_EEPROM_FAILURE,

	//SM_CH_SMTEMP_VERSION_NO,			//Version
	//SM_CH_SMTEMP_SERIAL_NO_HIGH,
	//SM_CH_SMTEMP_SERIAL_NO_LOW,
	//SM_CH_SMTEMP_BARCODE1,
	//SM_CH_SMTEMP_BARCODE2,
	//SM_CH_SMTEMP_BARCODE3,
	//SM_CH_SMTEMP_BARCODE4,

	//SM_CH_SMTEMP_SERIAL_NO,		//not used
	//SM_CH_SMTEMP_FEATURE,		//not used	

	SM_CH_SMTEMP_COMM_STAT,
	SM_CH_SMTEMP_EXIST_STAT,
};

enum SMTEMP_ROUGH_DATA_ID
{
	ROUGH_SMTEMP_TEMP1 = 0,
	ROUGH_SMTEMP_TEMP2,
	ROUGH_SMTEMP_TEMP3,
	ROUGH_SMTEMP_TEMP4,
	ROUGH_SMTEMP_TEMP5,
	ROUGH_SMTEMP_TEMP6,
	ROUGH_SMTEMP_TEMP7,
	ROUGH_SMTEMP_TEMP8,

	ROUGH_SMTEMP_TEMP1_STATUS,
	ROUGH_SMTEMP_TEMP2_STATUS,
	ROUGH_SMTEMP_TEMP3_STATUS,
	ROUGH_SMTEMP_TEMP4_STATUS,
	ROUGH_SMTEMP_TEMP5_STATUS,
	ROUGH_SMTEMP_TEMP6_STATUS,
	ROUGH_SMTEMP_TEMP7_STATUS,
	ROUGH_SMTEMP_TEMP8_STATUS,

	ROUGH_SMTEMP_ID_OVERLAP,
	ROUGH_SMTEMP_AD_FAIL,
	ROUGH_SMTEMP_EEPROM_FAIL,

	ROUGH_SMTEMP_FEATURE,
	ROUGH_SMTEMP_SERIAL_NO,
	ROUGH_SMTEMP_SERIAL_NO_HIGH,
	ROUGH_SMTEMP_SERIAL_NO_LOW,
	ROUGH_SMTEMP_BARCODE1,
	ROUGH_SMTEMP_BARCODE2,
	ROUGH_SMTEMP_BARCODE3,
	ROUGH_SMTEMP_BARCODE4,
	ROUGH_SMTEMP_VERSION_NO,

	ROUGH_SMTEMP_RUNTIME,

	ROUGH_SMTEMP_SEQ_NUM,
	ROUGH_SMTEMP_ADDR,
	ROUGH_SMTEMP_EXIST_STAT,
	ROUGH_SMTEMP_COMM_FAIL_TIMES,
	ROUGH_SMTEMP_COMM_STAT,

	ROUGH_SMTEMP_MAX_SIG_NUM,
};
enum SMTEMP_GROUP_ROUGH_DATA_ID
{
	ROUGH_GROUP_SMTEMP_GROUP_STATE = 0,
	ROUGH_GROUP_SMTEMP_G_COMM_STAT,			
	ROUGH_GROUP_SMTEMP_NUM,

	ROUGH_GROUP_SMTEMP_MAX_SIG_NUM,
};
enum enum_SMTEMP_Probe_Status
{
	SMTEMP_PROBE_NORMAL = 0,
	SMTEMP_PROBE_SHORTED,
	SMTEMP_PROBE_OPEN,
	SMTEMP_PROBE_NOT_INSTALL,
};
struct STRU_CAN_SAMP_SMTEMP
{
	BOOL	bNeedReconfig;
	BYTE	cBySendBuf[CAN_FRAME_LEN];
	BYTE	cByRecvBuf[MAX_FRAMES_IN_BUFF*13];	
	SAMPLING_VALUE aRoughData[CAN_SMTEMP_MAX_NUM][ROUGH_SMTEMP_MAX_SIG_NUM];
	SAMPLING_VALUE aRoughData_Group[ROUGH_GROUP_SMTEMP_MAX_SIG_NUM];

	//G3_OPT [loader], by Lin.Tao.Thomas, 2013-4
	BOOL    bConfigured;   //whether configured in the G3 solution
};

typedef	struct STRU_CAN_SAMP_SMTEMP	GLB_STRU_CAN_SAMP_SMTEMP;

struct _FRAME_DATA_STRUCT
{
	//INT32	iCanFrameStartPst;
	INT32	iValueType;
	INT32	iSignalType;//1:u	 0:float    2: byte
	INT32	iRoughDataIdx;
	//INT32	iFrameNum;
};
typedef struct _FRAME_DATA_STRUCT FRAME_DATA_STRUCT;

void SMTemp_StuffChannel(ENUMSIGNALPROC EnumProc,
			LPVOID lpvoid);	
void SMTemp_InitRoughValue(void);
void SMTemp_Sample(void);
void SMTemp_GetProdctInfo(HANDLE hComm, int nUnitNo, PRODUCT_INFO *pPI);
#endif



